Module | Merb::RenderMixin
In: | lib/merb-core/controller/mixins/render.rb

### Methods

_get_layout _handle_options! _template_for _template_method_for append_content catch_content clear_content display included partial render throw_content thrown_content?

### Included Modules

Merb::ControllerExceptions

### Classes and Modules

Module Merb::RenderMixin::ClassMethods

### Public Class methods

included(base)

#### Parameters

base<Module>: | Module that is including RenderMixin (probably a controller)

@private

### Public Instance methods

_get_layout(layout = nil)

Get the layout that should be used. The content-type will be appended to the layout unless the layout already contains a "." in it.

If no layout was passed in, this method will look for one with the same name as the controller, and finally one in "application.#{content_type}".

#### Parameters

layout<~to_s>: | A layout, relative to the layout root. Defaults to nil.

#### Returns

String: | The method name that corresponds to the found layout.

#### Raises

TemplateNotFound: | If a layout was specified (either via layout in the class or by passing one in to this method), and not found. No error will be raised if no layout was specified, and the default layouts were not found.

:api: private

_handle_options!(opts)

Take the options hash and handle it as appropriate.

#### Parameters

opts<Hash>: | The options hash that was passed into render.

#### Options

:status<~to_i>: | The status of the response will be set to opts[:status].to_i

#### Returns

Hash: | The options hash that was passed in.

:api: private

_template_for(context, content_type, controller=nil, template=nil, locals=[])

Iterate over the template roots in reverse order, and return the template and template location of the first match.

#### Parameters

context<Object>: | The controller action or template (basename or absolute path).
content_type<~to_s>: | The content type (like html or json).
controller<~to_s>: | The name of the controller. Defaults to nil.
locals<Array[Symbol]>: | A list of locals to assign from the args passed into the compiled template.

#### Options (opts)

:template<String>: | The location of the template to use. Defaults to whatever matches this context, content_type and controller.

#### Returns

Array[Symbol, String]: | A pair consisting of the template method and location.

:api: private

_template_method_for(template_location, locals)

Return the template method for a location, and check to make sure the current controller actually responds to the method.

#### Parameters

template_location<String>: | The phyical path of the template
locals<Array[Symbol]>: | A list of locals to assign from the args passed into the compiled template.

#### Returns

String: | The method, if it exists. Otherwise return nil.

:api: private

append_content(obj, string = nil, &block)

Called in templates to append content for later use. Works like throw_content.

@param [Object] obj

      Key used in the thrown_content hash.

@param [String] string

      Textual content. Default to nil.

@yield

      Evaluated with result concatenated to string.

@raise [ArgumentError]

      Neither string nor block given

:api: public

catch_content(obj = :for_layout)

Called in templates to get at content thrown in another template. The results of rendering a template are automatically thrown into :for_layout, so catch_content or catch_content(:for_layout) can be used inside layouts to get the content rendered by the action template.

#### Parameters

obj<Object>: | The key in the thrown_content hash. Defaults to :for_layout.

:api: public

clear_content(obj = :for_layout)

Called when renderers need to be sure that existing thrown content is cleared before throwing new content. This prevents double rendering of content when multiple templates are rendered after each other.

#### Parameters

obj<Object>: | The key in the thrown_content hash. Defaults to :for_layout.

:api: public

display(object, thing = nil, opts = {})

Renders an object using to registered transform method based on the negotiated content-type, if a template does not exist. For instance, if the content-type is :json, Merb will first look for current_action.json.*. Failing that, it will run object.to_json.

#### Parameter

object<Object>: | An object that responds_to? the transform method registered for the negotiated mime-type.
thing<String, Symbol>: | The thing to attempt to render via render before calling the transform method on the object. Defaults to nil.
opts<Hash>: | An options hash that will be used for rendering (passed on to render or serialization methods like to_json or to_xml)

#### Returns

String: | The rendered template or if no template is found, the transformed object.

#### Raises

NotAcceptable: | If there is no transform method for the specified mime-type or the object does not respond to the transform method.

#### Alternatives

A string in the second parameter will be interpreted as a template:

      display @object, "path/to/foo"
      #=> display @object, nil, :template => "path/to/foo"

A hash in the second parameters will be interpreted as opts:

      display @object, :layout => "zoo"
      #=> display @object, nil, :layout => "zoo"

If you need to pass extra parameters to serialization method, for instance, to exclude some of attributes or serialize associations, just pass options for it. For instance,

display @locations, :except => [:locatable_type, :locatable_id], :include => [:locatable]

serializes object with polymorphic association, not raw locatable_* attributes.

#### Options

:template a template to use for rendering :layout a layout to use for rendering :status the status code to return (defaults to 200) :location the value of the Location header

all other options options that will be pass to serialization method

                             like #to_json or #to_xml

#### Notes

The transformed object will not be used in a layout unless a :layout is explicitly passed in the opts.

:api: public

partial(template, opts={})

Render a partial template.

#### Parameters

template<~to_s>: | The path to the template, relative to the current controller or the template root; absolute path will work too. If the template contains a "/", Merb will search for it relative to the template root; otherwise, Merb will search for it relative to the current controller.
opts<Hash>: | A hash of options (see below)

#### Options (opts)

:with<Object, Array>: | An object or an array of objects that will be passed into the partial.
:as<~to_sym>: | The local name of the :with Object inside of the partial.
:format<Symbol>: | The mime format that you want the partial to be in (:js, :html, etc.)
others: | A Hash object names and values that will be the local names and values inside the partial.

#### Examples

      partial :foo, :hello => @object

The "_foo" partial will be called, relative to the current controller, with a local variable of `hello` inside of it, assigned to @object.

      partial :bar, :with => ['one', 'two', 'three']

The "_bar" partial will be called once for each element of the array specified by :with for a total of three iterations. Each element of the array will be available in the partial via a local variable named `bar`. Additionally, there will be two extra local variables: `collection_index` and `collection_size`. `collection_index` is the index of the object currently referenced by `bar` in the collection passed to the partial. `collection_size` is the total size of the collection.

By default, the object specified by :with will be available through a local variable with the same name as the partial template. However, this can be changed using the :as option.

      partial :bar, :with => "one", :as => :number

In this case, "one" will be available in the partial through the local variable named `number`.

:api: public

render(thing = nil, opts = {})

Render the specified item, with the specified options.

#### Parameters

thing<String, Symbol, nil>: | The thing to render. This will default to the current action
opts<Hash>: | An options hash (see below)

#### Options (opts)

:format<Symbol>: | A registered mime-type format
:template<String>: | The path to the template relative to the template root
:status<~to_i>: | The status to send to the client. Typically, this would be an integer (200), or a Merb status code (Accepted)

:layout<~to_s, FalseClass>:

A layout to use instead of the default. This should be relative to the layout root. By default, the layout will be either the controller_name or application. If you want to use an alternative content-type than the one that the base template was rendered as, you will need to do :layout => "foo.#{content_type}" (i.e. "foo.json"). If you want to render without layout, use :layout => false. This overrides layout set by `layout` method.

#### Returns

String: | The rendered template, including layout, if appropriate.

#### Raises

TemplateNotFound: | There is no template for the specified location.

#### Alternatives

If you pass a Hash as the first parameter, it will be moved to opts and "thing" will be the current action

:api: public

throw_content(obj, string = nil, &block)

Called in templates to store up content for later use. Takes a string and/or a block. First, the string is evaluated, and then the block is captured using the capture() helper provided by the template languages. The two are concatenated together.

#### Parameters

obj<Object>: | The key in the thrown_content hash.
string<String>: | Textual content. Defaults to nil.
&block: | A block to be evaluated and concatenated to string.

#### Raises

ArgumentError: | Neither string nor block given.

#### Example

      throw_content(:foo, "Foo")
      catch_content(:foo) #=> "Foo"

:api: public

thrown_content?(obj = :for_layout)

Called in templates to test for the existence of previously thrown content.

#### Parameters

obj<Object>: | The key in the thrown_content hash. Defaults to :for_layout.

:api: public

[Validate]